;;; howmoney.el -- easy account book
;; Copyright (c) 2004 by YAMAMIYA Takasi <propella@yuri.sakura.ne.jp>
;; $Id: howmoney.el,v 1.23 2004/05/23 15:03:28 propella Exp $
;;
;; This program is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 1, or (at your option)
;; any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; The GNU General Public License is available by anonymouse ftp from
;; prep.ai.mit.edu in pub/gnu/COPYING.  Alternately, you can write to
;; the Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139,
;; USA.
;;--------------------------------------------------------------------

;;;
;; դȻȤ (ۤˤϱߤդƤդʤƤɤ)
;; $$ å ݥ ʤ᤿  Ǭ ǼƦ ʪ  2062
;;
;; >>> $$
;; Τ褦˲褫˽񤤤 howm ƤӽФ
;; ΥХåե M-x howmoney-daily
;;
;; 2004-02-25	1234
;; 2004-02-24	1008
;; 2004-02-23	488
;;
;; ʴǽפ롣>>> 񤯤Τݤʤ顢
;; M-x howmoney-daily  $ʤȤ$ ˴ؤ餺­˽ס
;; β̤ǡ@ 򲡤ȡ⤦ܤɽ(֤ưƤ)
;; β̤ǡp 򲡤ȡоݤδ֤ȡȡȤѤ롣
;;
;; ʲΤ褦˽񤤤 M-x howminutes-daily ǡä֤⽸׽ޤ
;; 17:00-19:00 @̡@ 르 ԡ
;;
;; ޤεǽٱ礹٤ˡC-c , C-t ǥॹפưŪˤĤ뵡ǽ⤢ꡣ
;; = today ޤޤ˼ưŪ˥ॹפ񤫤ޤ

(require 'howm-view)
(require 'howm-date)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Customize 1 (easy)

;;; Code:
(defvar howmoney-week-start-day 1
  "The day of the week on which a week in the howomney calender begins.
0 means Sunday , 1 means Monday (default), and so on.")

(defvar howminutes-timestamp-start 5
  "Hour of a date starts for `howminutes-timestamp'.")

(global-set-key "\C-c,\C-t" 'howminutes-timestamp)

(defvar howmoney-tag-regexp "\\$[^\\$]*\\$"
  "Regexp for filtering account line.")

(defvar howminutes-tag-regexp "\\@[^\\@]*\\@"
  "Regexp for filtering account line.")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Customize 2 (fine)

(defvar howmoney-money-regexp "\\([0-9,]+\\)[^0-9,]*$"
  "Regexp for money.")

(defvar howmoney-summary-name "*howmoney*")

(defvar howmoney-date-regexp "\\([1-9][0-9][0-9][0-9]\\)[-_]\\([0-9][0-9]\\)[-_]\\([0-9][0-9]\\)")

(defvar howminutes-time-regexp "^\\([0-9][0-9]\\):\\([0-9][0-9]\\)[-|/]\\([0-9][0-9]\\):\\([0-9][0-9]\\)"
  "Regexp for period of time.")

(defvar howmoney-monthly-regexp
  "[1-9][0-9][0-9][0-9][-_][0-9][0-9]")

(defvar howminutes-timestamp-regexp "[0-9][0-9]:[0-9][0-9]- ")
(defvar howminutes-timestamp-today-regexp "^= today")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; For compatibility

(unless (fboundp 'howm-view-summary-show)
  (defalias 'howm-view-summary-show 'riffle-summary-show))

(defun howm-view-set-item-list (item-list)
  (mapcar
   (lambda (var)
	 (when (boundp var)
	   (set var item-list)))
   '(riffle-item-list howm-view-item-list)))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; User interface

(defvar howmoney-show-detail nil
  "t when show detail")

(defvar howmoney-last-query nil)

(defvar howmoney-toggle-period-map
  '((howmoney-daily-prod . howmoney-weekly-prod)
	(howmoney-weekly-prod . howmoney-monthly-prod)
	(howmoney-monthly-prod . howmoney-daily-prod)))

(defvar howmoney-cache-item-list nil
  "see `howm-view-item-list'")

(defun howmoney-version ()
  (interactive)
  (message "%s" "$Revision: 1.23 $"))

(defun howmoney ()
  (interactive)
  (if howmoney-last-query
	  (apply 'howmoney-general howmoney-last-query)
	(howmoney-daily)))

(defun howminutes-daily ()
  "Search time record and count daily."
  (interactive)
  (howmoney-general howminutes-tag-regexp 'howmoney-daily-prod 'howminutes-number)
  )

(defun howminutes-weekly ()
  "Search time record and count weekly."
  (interactive)
  (howmoney-general howminutes-tag-regexp 'howmoney-weekly-prod 'howminutes-number)
  )

(defun howminutes-monthly ()
  "Search time record and count monthly."
  (interactive)
  (howmoney-general howminutes-tag-regexp 'howmoney-monthly-prod 'howminutes-number)
  )

(defun howmoney-daily ()
  "Search money record and count daily."
  (interactive)
  (howmoney-general howmoney-tag-regexp 'howmoney-daily-prod 'howmoney-number)
  )

(defun howmoney-weekly ()
  "Search money record and count weekly."
  (interactive)
  (howmoney-general howmoney-tag-regexp 'howmoney-weekly-prod 'howmoney-number)
  )

(defun howmoney-monthly ()
  "Search money record and count monthly."
  (interactive)
  (howmoney-general howmoney-tag-regexp 'howmoney-monthly-prod 'howmoney-number)
  )

(defun howmoney-search ()
  "Show line deal with money.
These includes $tag$ string and the last word should be number."
  (interactive)
  (howmoney-search-general howmoney-tag-regexp 'howmoney-number)
  )

(defun howminutes-search ()
  "Show line deal time record.
These includes @tag@ string and the first word should be period of time."
  (interactive)
  (howmoney-search-general howminutes-tag-regexp 'howminutes-number)
  )

(defun howmoney-kill-buffer ()
  "Kill howmoney buffers."
  (interactive)
  (kill-buffer (howmoney-summary-buffer))
  (switch-to-buffer (howm-view-summary-buffer)))

(defun howmoney-summary-open ()
  (interactive)
  (switch-to-buffer (howm-view-summary-buffer)))

(defun howmoney-toggle-show-detail ()
  (interactive)
  (setq howmoney-show-detail (not howmoney-show-detail))
  (apply 'howmoney-general howmoney-last-query))

(defun howmoney-toggle-period ()
  (interactive)
  (let ((last-period (nth 1 howmoney-last-query)))
	(apply 'howmoney-general
		   (list (nth 0 howmoney-last-query)
				 (cdr (assoc last-period howmoney-toggle-period-map))
				 (nth 2 howmoney-last-query)))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Timestamp

(defun howminutes-timestamp ()
  "Insert current time into today's memo."
  (interactive)
  (let* ((started (howminutes-timestamp-findfile howminutes-timestamp-regexp)))
	(if started
		(progn (find-file started)
			   (beginning-of-buffer)
			   (re-search-forward howminutes-timestamp-regexp)
			   (backward-char)
			   (howminutes-timestamp-insert))
	  (let ((today (howminutes-timestamp-findfile howminutes-timestamp-today-regexp)))
		(if today (find-file today) (howm-create-file-with-title "today" nil))
		(run-hooks 'howm-view-open-hook)
		(end-of-buffer)
		(unless (bolp) (insert "\n"))
		(howminutes-timestamp-insert)
		(insert "- ")))))

(defun howminutes-timestamp-findfile (regexp)
"Helper function to find a pattern in today's files.
Argument REGEXP"
  (car (car
		(howm-view-fake-grep
		 regexp
		 (let* ((full
				 (expand-file-name
				  (howm-file-name (howminutes-current-time (current-time))) howm-directory))
				(dir
				 (file-name-directory full))
				(pattern
				 (format "%s.*.howm" (substring (file-name-nondirectory full) 0 10))))
		   (directory-files dir t pattern t))))))

(defun howminutes-current-time (time)
  (let ((decoded (decode-time time)))
	(if (< (nth 2 decoded) howminutes-timestamp-start)
		(encode-time 0 0 0
					 (1- (nth 3 decoded))
					 (nth 4 decoded)
					 (nth 5 decoded))
	  time)))
; (current-time-string (howminutes-current-time (encode-time 0 0 0 9 3 2004)))
;   => "Mon Mar 08 00:00:00 2004"
; (current-time-string (howminutes-current-time (encode-time 59 59 4 9 3 2004)))
;   => "Mon Mar 08 00:00:00 2004"
; (current-time-string (howminutes-current-time (encode-time 1 0 5 9 3 2004)))
;  => "Tue Mar 09 05:00:01 2004"

(defun howminutes-timestamp-insert ()
  (insert (format-time-string "%R" (current-time))))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Mode

(defvar howmoney-view-summary-mode-hook nil)

(defun howmoney-mode ()
  "Counting result viewer

key	binding
---	-------
\\[howmoney-summary-open]	Jump to patient howm summary item
\\[howmoney-toggle-period]	Toggle period (daily -> weekly -> monthly)
\\[howmoney-toggle-show-detail]	Toggle show or hide detail
\\[howmoney-kill-buffer]	Quit"
  (interactive)
  (setq major-mode 'howmoney-mode)
  (setq mode-name "Howmoney")
  (let ((m (make-keymap)))
    (define-key m "\C-m" 'howmoney-summary-open)
    (define-key m "q" 'howmoney-kill-buffer)
    (define-key m "p" 'howmoney-toggle-period)
    (define-key m "@" 'howmoney-toggle-show-detail)
    (define-key m "m" 'howmoney-show-as-time)
	(use-local-map m))
  (make-local-hook 'post-command-hook)
  (add-hook 'post-command-hook 'howmoney-post-command t t)
  (run-hooks 'howmoney-view-summary-mode-hook))

(defun howmoney-post-command ()
  (howmoney-summary-check))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Internal

(defun howmoney-summary-check ()
  (let* ((line-number (howm-view-line-number))
		 (item-lines (nth (1- line-number) howmoney-items))
		 (item-list (nth 2 item-lines)))
	(unless item-list
	  (setq item-list
			(howmoney-correct-original-items howmoney-items)))
	(when item-list
	  (with-current-buffer (howm-view-summary-buffer)
		(howm-view-set-item-list item-list)
		(howm-view-summary-show item-list)))))

(defun howmoney-correct-original-items (items)
  (apply 'append
		 (mapcar
		  (lambda (item) (nth 2 item))
		  items)))
; (howmoney-correct-original-items
;  '((date1 number2 (("file1" "sample1") ("file2" "sample2"))) (date2 number2 (("file3" "sample3")))))
;   => (("file1" "sample1") ("file2" "sample2") ("file3" "sample3"))

(defvar howmoney-items nil
  "List of account data
howmoney-items = ((date money item-list) ...)")
(make-variable-buffer-local 'howmoney-items)

(defun howmoney-search-general (tag-regexp match-prod)
  "Search by tag regexp (like $...$), and in addition filter by if they have correct number form."
  (let ((howm-list-title nil)
		(howm-list-all-title nil)
		(howm-list-recent-title nil))
	(howm-search tag-regexp nil)
	(howm-view-filter-general
	 (lambda (item)
	   (funcall match-prod (funcall 'howm-view-item-summary item))))
	(howm-view-sort-by-date)
	(howm-view-item-list)))

(defun howmoney-general (tag-regexp period-prod match-prod)
  "General accounting and displaying function.
TAG-REGEXP destinct howmoney or howminutes, it is just used when
for `howmoney-search-general' or detail search.
PERIOD-PROD is function to classfying for group (daily, monthly, or weekly)
MATCH-PROD is function to match and return number (money or minutes)."
  (setq howmoney-last-query (list tag-regexp period-prod match-prod))

;  (unless (eq major-mode 'howm-view-summary-mode)
;	(howmoney-search-general tag-regexp match-prod))
;  (unless (howm-view-item-list)
;	(howmoney-search-general tag-regexp match-prod))
  
  (let* ((item-list (or (howm-view-item-list)
						howmoney-cache-item-list
						(howmoney-search-general tag-regexp match-prod)))
		(items (howmoney-items tag-regexp period-prod match-prod item-list)))
	(howmoney-setup-window-configuration)
	(howmoney-mode)
	(setq buffer-read-only nil)
	(erase-buffer)
	(howmoney-show-howmoney-items items)
	(goto-char (point-min))
	(set-buffer-modified-p nil)
	(setq buffer-read-only t)
	(setq howmoney-items items)
	(howm-view-set-item-list item-list) ; to syncronized to howm
;	(setq howm-view-item-list item-list) ; to syncronized to howm
	))

(defun howmoney-items (tag-regexp period-prod match-prod item-list)
  (let* ((item-lines (howmoney-item-lines tag-regexp period-prod match-prod item-list))
		 (items (howmoney-make-item item-lines)))
	(sort items
		  (lambda (a b) (string< (car b) (car a))))))
  
(defun howmoney-item-lines (tag-regexp period-prod match-prod item-list)
  "Make a list of (key value item) for make variable `howmoney-items'.
ITEM-LIST is data source from function `howm-view-item-list'.
An item is an element of howm-view-item-list"
  (let ((key-format (if howmoney-show-detail "%s\t%s" "%s"))
		item-lines)
	(mapcar
	 (lambda (item)
	   (let* ((key-date (funcall period-prod (howm-view-item-filename item)))
			  (key-tag (let ((summary (howm-view-item-summary item)))
						 (and (string-match tag-regexp summary)
							  (match-string 0 summary))))
			  (key (format key-format key-date key-tag))
			  (value
			   (funcall match-prod (funcall 'howm-view-item-summary item))))
		 (when (and key-date value)
		   (setq item-lines (append item-lines (list (list key value item)))))))
	 item-list)
	item-lines))
;; (howmoney-item-lines howmoney-tag-regexp 'howmoney-daily-prod 'howmoney-number '(("2004-02-01-12345.howm" "$$ Ԥ 320" foo foo) ("2004-02-01-45679.howm" "$$ 4F 1800" fuga hoge)))
;;  => (("2004-02-01	$$" 320 ("2004-02-01-12345.howm" "$$ Ԥ 320" foo foo))
;;      ("2004-02-01	$$" 1800 ("2004-02-01-45679.howm" "$$ 4F 1800" fuga hoge)))

(defun howmoney-make-item (item-lines)
  "Count minor total."
  (let ((table (howmoney-dict-new)))
	(mapcar
	 (lambda (line)
	   (let ((key (nth 0 line))
			 (value (nth 1 line))
			 (item-list (list (nth 2 line)))
			 (default '(0 nil)))
		 (setq value (+ value
						(car (or (howmoney-dict-get table key)
								 (howmoney-dict-set table key default)))))
		 (setq item-list (append (cadr (howmoney-dict-get table key))
								 item-list))
		 (howmoney-dict-set table key (list value item-list))))
	 item-lines)
	(howmoney-dict-to-alist table)))
;; (howmoney-make-item '(("apple" 10 line1) ("orange" 5 line2) ("apple" 15 line3) ("apple" 5 line4)))
;;  => (("apple" 30 (line1 line3 line4)) ("orange" 5 (line2)))

(defun howmoney-add-value-to-item (item value)
"Put number into summary string for useful to see minutes."
  (let ((file (car item))
		(summary (car (cdr item)))
		(rest (cdr (cdr item))))
	(append (list file (format "(%d)%s" value summary)) rest)
  ))
;; (howmoney-add-value-to-item '("file" "summary" 1 1 1 nil) 100)
;;  => ("file" "summary (100)" 1 1 1 nil)

(defun howmoney-show-howmoney-items (items)
  "Show variable `howmoney-items'.
Argument ITEMS items for howmoney."
  (mapcar
   (lambda (item)
	 (insert (format "%s\t%s" (car item) (cadr item)) "\n"))
   items))
;; (howmoney-show-howmoney-items '(("test" "TEST" (a b)) ("try" "TRY" (c d))))

(defun howmoney-format-item (item)
	 (format "%s\t%s" (car item) (cadr item)))
;; (howmoney-format-item '("test" "TEST" (a b)))
;;  => "test	TEST"

;;(defun howmoney-format-item (item)
;;	 (format "%s\t%s" (car item) (cadr item)))
;;(howmoney-format-item '("date" 100 (("file" "$book$ 50") ("file" "$book$ 50"))))

(defun howmoney-number (line)
  "Answer number at last of the line or nil."
  (and (string-match howmoney-money-regexp line)
	   (let ((number-string (match-string 1 line)))
		 (cond ((zerop (string-to-number number-string)) nil)
			   (t (string-to-number number-string))))))
;(eq (howmoney-number "a b 100") 100)
;(eq (howmoney-number "a b c 0") nil)
;(eq (howmoney-number "a b") nil)
;(eq (howmoney-number "") nil)

(defun howminutes-number (line)
  "Answer number at last of the line or nil."
  (when (string-match howminutes-time-regexp line)
	(let ((hour1 (string-to-number (match-string 1 line)))
		  (min1 (string-to-number (match-string 2 line)))
		  (hour2 (string-to-number (match-string 3 line)))
		  (min2 (string-to-number (match-string 4 line))))
	  (mod (- (+ (* hour2 60) min2) (+ (* hour1 60) min1)) (* 24 60)))))
;(eq (howminutes-number "13:00-15:00 @sq@ ǹ礻") 120)
;(eq (howminutes-number "01:00-02:35 @howmoney@ ֵϿ") 95)
;(eq (howminutes-number "23:00-01:00 @skel@ Х 5963") 120)
;(eq (howminutes-number "23:30-00:30") 60)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Buffers

(defun howmoney-setup-window-configuration ()
  (delete-other-windows)
  (let ((s (howmoney-summary-buffer))
        (c (howm-view-summary-buffer)))
    (switch-to-buffer c)
	(howm-view-summary-mode)
    (if howm-view-split-horizontally
        (split-window-horizontally)
      (split-window))
    (switch-to-buffer s)
    ))

(defun howmoney-summary-buffer (&optional new)
  (howm-view-get-buffer howmoney-summary-name nil new))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; classfying

(defun howmoney-daily-prod (filename)
  "Normalization date string made from filename"
  (when (string-match howmoney-date-regexp filename)
		(match-string 0 filename)))
;; (howmoney-daily-prod "c:/takasi/memo/2004/02/2004-02-22-090943.howm")
;;   => "2004-02-22"
;; (howmoney-daily-prod "c:/takasi/memo/2004/02/2004_02_22.howm")
;;   => "2004_02_22"

(defun howmoney-weekly-prod (filename)
  "Normalization date string made from filename"
  (when (string-match howmoney-date-regexp filename)
	(let* ((time (howm-datestr-to-time filename))
		   (numweek (string-to-number (format-time-string "%W" time)))
		   (year (string-to-number (format-time-string "%Y" time)))
		   (start (howmoney-numweek-to-date year numweek))
		   (start-list (decode-time start))
		   (end (encode-time 0 0 0
							 (+ 6 (nth 3 start-list))
							 (nth 4 start-list)
							 (nth 5 start-list))))
	  (format "%s/%s"
			  (format-time-string howm-date-format start)
			  (format-time-string howm-date-format end)))))
;; (howmoney-weekly-prod "c:/takasi/memo/2004/02/2004-02-24-090943.howm")
;;   => "2004-02-23/2004-02-29"
;; (howmoney-weekly-prod "c:/takasi/memo/2004/02/2004_02_24.howm")
;;   => "2004-02-23/2004-02-29"

(defun howmoney-monthly-prod (filename)
  "Normalization date string made from filename."
  (when (string-match howmoney-monthly-regexp filename)
		(match-string 0 filename)))
;; (howmoney-monthly-prod "c:/takasi/memo/2004/02/2004-02-22-090943.howm")
;;   => "2004-02"
;; (howmoney-monthly-prod "c:/takasi/memo/2004/02/2004_02_22.howm")
;;   => "2004_02"

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; utilities

;;; date convertion
(defun howmoney-numweek-to-date (year numweek)
  "Answer start time-value of week number starting on Monday of year.
(First week is 0)"
  (let* ((new-years-day (encode-time 0 0 0 1 1 year))
		 (start-week-of-year (string-to-number (format-time-string "%w" new-years-day)))
		 (offset (mod (+ start-week-of-year (- 7 howmoney-week-start-day)) 7))
		 (days (- (* 7 numweek) offset)))
	(encode-time 0 0 0 (1+ days) 1 year)))
;; (current-time-string (howmoney-numweek-to-date 2004 1))
;;   => "Mon Jan 05 00:00:00 2004"
;; (current-time-string (howmoney-numweek-to-date 2001 1))
;;   => "Mon Jan 08 00:00:00 2001"
;; (current-time-string (howmoney-numweek-to-date 1995 1))
;;   => "Mon Jan 02 00:00:00 1995"

;;; hash utility
(defun howmoney-dict-new ()
  (make-vector 3 0))
(defun howmoney-dict-set (dict key value)
  (set (intern key dict) value))
(defun howmoney-dict-get (dict key)
   (symbol-value (intern-soft key dict)))
(defun howmoney-dict-keys (dict)
  (let ((keys))
	(mapatoms (lambda (sym)
				(setq keys (cons (symbol-name sym) keys)))
			  dict)
	keys))


(defun howmoney-dict-to-alist (dict)
  (let ((alist))
	(mapatoms (lambda (key)
				(setq alist
					  (cons
					   (cons (symbol-name key) (howmoney-dict-get dict (symbol-name key)))
					   alist)))
			  dict)
	alist))
;; (setq dic (howmoney-dict-new))
;; (howmoney-dict-set dic "hello" "ok")
;; (howmoney-dict-set dic "bye" "night")
;; (howmoney-dict-keys dic)
;; (howmoney-dict-to-alist dic)

(provide 'howmoney)

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Omake kinou
(defun howmoney-show-as-time (number)
  (interactive "nMinutes:")
  (message  "%02d:%02d" (/ number 60) (mod number 60)))

(defvar howmoney-pivot-excel-file "c:/takasi/doc/lisp/howmoney.xls")
(defun howmoney-make-graph ()
  "Make graph in *howmoney* buffer with ms-excel
See http://languagegame.org:8080/propella/84"
  (interactive)
  (kill-ring-save (point-min) (point-max))
  (start-process
   "fiber" nil "fiber.exe" howmoney-pivot-excel-file))

(defun howmoney-lapse-region (begin end)
  "Calculate each lapse times in region.
Try followed example (select these lines and execute this command).

09:30-09:45 meeting
09:50-12:00 implementation for database
12:00-12:55 [01:00] lunch
23:00-00:30 network trouble shooting
"
  (interactive "r")
  (let* ((lines (split-string (buffer-substring begin end) "\n"))
		 begin-hour begin-min end-hour end-min tail lapse lapse-str)
	(delete-region begin end)
	(mapcar
	 (lambda (line)
	   (if (string-match "\\([0-9][0-9]\\):\\([0-9][0-9]\\)-\\([0-9][0-9]\\):\\([0-9][0-9]\\)\\( \[[0-9:]*\]\\)? \\(.*\\)" line)
		   (progn (setq begin-hour (string-to-number (match-string 1 line)))
				  (setq begin-min (string-to-number (match-string 2 line)))
				  (setq end-hour (string-to-number (match-string 3 line)))
				  (setq end-min (string-to-number (match-string 4 line)))
				  (setq tail (match-string 6 line))
				  (setq lapse (mod (- (+ (* end-hour 60) end-min) (+ (* begin-hour 60) begin-min)) (* 24 60)))
				  (setq lapse-str (format "%02d:%02d" (/ lapse 60) (mod lapse 60)))
				  (insert (format "%02d:%02d-%02d:%02d [%s] %s\n" begin-hour begin-min end-hour end-min lapse-str tail)))
		 (insert (format "%s\n" line))))
				  lines)))

(defun howmoney-list-dependent-symbol ()
  "This utility function tells you dependent simbol like `howm-*'."
  (interactive)
  (let ((prev "") (uniq '("")) found )
	(with-temp-buffer
	(lisp-mode)
	(insert-file-contents(symbol-file 'howmoney))
	(while (re-search-forward "[^-]\\(howm-[a-zA-Z-]*\\)" nil t)
	  (setq found (cons (buffer-substring-no-properties (match-beginning 1) (match-end 1))
						found))))
	(mapcar (lambda (string)
			  (unless (string= (car uniq) string)
				(setq uniq (cons string uniq))))
			(sort found 'string<))
	(with-output-to-temp-buffer "*result*"
	  (mapcar (lambda (string)
				(princ (format "%s\n" string)))
			  (cdr (reverse uniq))))
))
